image: ubuntu:focal

stages:
    - download
    - build
    - package
    - deploy

variables:
    DEBIAN_FRONTEND: noninteractive

get_godot:
    stage: download
    script:
        - apt-get -y update && apt-get install -y curl unzip zip
        - curl -SsL https://downloads.tuxfamily.org/godotengine/3.4.4/Godot_v3.4.4-stable_linux_headless.64.zip -o godot.zip
        - unzip godot.zip
        - mv Godot_v3.4.4-stable_linux_headless.64 godot
        - chmod +x godot
        - curl -SsL https://downloads.tuxfamily.org/godotengine/3.4.4/Godot_v3.4.4-stable_export_templates.tpz -o godot_templates.zip
        - unzip godot_templates.zip
        - rm godot_templates.zip
        - cd templates
        - zip godot_templates.zip *
        - cd ../
        - mv templates/godot_templates.zip .
    artifacts:
        paths:
            - godot
            - godot_templates.zip
        expire_in: 3 days

linux:build:
    stage: build
    script:
        - apt-get -y update && apt-get install -y unzip
        - export PATH=./:$PATH
        - ./build.sh
    dependencies:
        - get_godot
    artifacts:
        paths:
            - wordable.out
            - wordable.pck
        expire_in: 3 days

windows:build:
    stage: build
    script:
        - apt-get -y update && apt-get install -y unzip
        - export PATH=./:$PATH
        - ./build_windows.sh
    dependencies:
        - get_godot
    artifacts:
        paths:
            - wordable.exe
            - wordable.pck
        expire_in: 3 days

macos:build:
    stage: build
    script:
        - apt-get -y update && apt-get install -y unzip
        - export PATH=./:$PATH
        - ./build_macos.sh
        - mv wordable.zip wordable_mac.zip
    artifacts:
        paths:
            - wordable_mac.zip
        expire_in: 3 days

linux:package:
    stage: package
    script:
        - apt-get -y update && apt-get install -y zip
        - zip wordable_linux.zip wordable.out wordable.pck
    dependencies:
        - linux:build
    artifacts:
        paths:
            - wordable_linux.zip
        expire_in: 3 days

windows:package:
    stage: package
    script:
        - apt-get -y update && apt-get install -y zip
        - zip wordable_windows.zip wordable.exe wordable.pck
    dependencies:
        - windows:build
    artifacts:
        paths:
            - wordable_windows.zip
        expire_in: 3 days

itch:deploy:
    stage: deploy
    when: manual
    only:
        - main
    script:
        - apt-get update -y && apt-get install -y curl unzip
        - curl -SsL -o butler.zip https://broth.itch.ovh/butler/linux-amd64/LATEST/archive/default
        - unzip butler.zip
        - chmod +x butler
        - ./butler -V
        - ./butler push wordable_windows.zip anthonysmith/wordable:windows
        - ./butler push wordable_linux.zip anthonysmith/wordable:linux
        - ./butler push wordable_mac.zip anthonysmith/wordable:mac
    dependencies:
        - linux:package
        - windows:package
        - macos:build

